package edu.assistment.common.view;

import javax.swing.JTextField;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * Update the value of a JLabel based on the value of a JSlider
 * 
 * @author Mike Sao Pedro (mikesp@wpi.edu)
 */
public class SliderTextFieldUpdateController implements ChangeListener 
{
	private JTextField sliderLabel;
	private JSlider slider;
	
	public SliderTextFieldUpdateController(JSlider slider, JTextField label)
	{
		this.slider = slider;
		sliderLabel = label;
		slider.addChangeListener(this);
	}

	public void stateChanged(ChangeEvent e) 
	{
		if(e.getSource() != slider)
			throw new IllegalArgumentException("Unknown source: " + e.getSource().toString());
		
		sliderLabel.setText(Integer.toString(slider.getValue()));
		
	}
	
	
}
