package edu.assistment.experiments.inclinedplane;
import com.cloudgarden.layout.AnchorConstraint;
import com.cloudgarden.layout.AnchorLayout;

import edu.assistment.experiments.inclinedplane.controller.InclineAngleComboBoxController;
import edu.assistment.experiments.inclinedplane.controller.InclineAngleSliderController;
import edu.assistment.experiments.inclinedplane.controller.BallTypeController;
import edu.assistment.experiments.inclinedplane.controller.RampTypeController;
import edu.assistment.experiments.inclinedplane.controller.RunLengthAngleComboBoxController;
import edu.assistment.experiments.inclinedplane.controller.RunLengthTypeController;
import edu.assistment.experiments.inclinedplane.controller.SimulationController;
import edu.assistment.experiments.inclinedplane.controller.StartPositionComboBoxController;
import edu.assistment.experiments.inclinedplane.controller.StartPositionSliderController;
import edu.assistment.experiments.inclinedplane.model.InclinedPlaneModel;
import edu.assistment.experiments.inclinedplane.view.InclinedPlaneCanvas;
import edu.assistment.experiments.inclinedplane.view.InclinedPlaneExperimentComboBoxJPanel;
import edu.assistment.experiments.inclinedplane.view.InclinedPlaneSimulationJPanel;
import edu.assistment.experiments.inclinedplane.view.InclinedPlaneSliderJPanel;
import edu.assistment.experiments.pedagogy.PedagogicalAgent;
import edu.assistment.simulation.view.PedagogyJPanel;
import edu.assistment.simulation.view.SimulationControlJPanel;

import edu.assistment.common.view.*;

import java.awt.BorderLayout;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JApplet;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.SwingUtilities;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class InclinePlane extends javax.swing.JFrame implements ComponentListener
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -7712980271677270275L;
	
	private InclinedPlaneExperimentComboBoxJPanel mainPanel;
	private SimulationController simController;
	private StartPositionComboBoxController startPosController;
	private InclineAngleComboBoxController inclineAngleController;
	private PedagogyJPanel pedagogyPanel;
	private RunLengthAngleComboBoxController runLengthAngleController;
	private RunLengthTypeController runLengthTypeController;
	private InclinedPlaneModel model;
	private BallTypeController ballTypeController;
	private RampTypeController rampTypeController;
	
	// --- The SMARTS!!
	private PedagogicalAgent agent;
	
	/**
	* Auto-generated main method to display this 
	* JApplet inside a new JFrame.
	*/
	public static void main(String[] args) {
		
		InclinePlane inst = new InclinePlane();

		    inst.addWindowListener(new WindowAdapter() 
		    {
		        public void windowClosing(WindowEvent e) {System.exit(0);}
		    });

		    inst.pack();
		    inst.setVisible(true);
		}
	
	public InclinePlane() {
		super();
		initModels();
		initGUI();
		initControllers();
		initSystem();
	}
	
	private void initSystem()
	{
		simController.resetExperiment();
		
		// --- Cheat to make viz match values in JComponents
		this.inclineAngleController.actionPerformed(null);
		this.runLengthAngleController.actionPerformed(null);
		this.startPosController.actionPerformed(null);
		
		agent = new PedagogicalAgent(mainPanel, simController, model);
		
	}
	
	private void initGUI() {
		try {
			GridLayout thisLayout = new GridLayout(1, 1);
			thisLayout.setColumns(1);
			thisLayout.setHgap(1);
			thisLayout.setVgap(1);
			getContentPane().setLayout(thisLayout);
			this.setSize(1600, 588);
			this.setName("Inclined Plane Experiment");
			{
				mainPanel = new InclinedPlaneExperimentComboBoxJPanel(model);
				getContentPane().add(mainPanel);
				mainPanel.getInclinedPlaneExperimentJPanel().setPreferredSize(new java.awt.Dimension(661, 168));
				mainPanel.getInclinedPlaneCanvas1().setPreferredSize(new java.awt.Dimension(816, 391));
				{
					pedagogyPanel = new PedagogyJPanel();
					mainPanel.add(pedagogyPanel, new AnchorConstraint(408, 997, 978, 654, AnchorConstraint.ANCHOR_REL, AnchorConstraint.ANCHOR_REL, AnchorConstraint.ANCHOR_REL, AnchorConstraint.ANCHOR_REL));
					pedagogyPanel.setPreferredSize(new java.awt.Dimension(407, 301));
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public InclinedPlaneExperimentComboBoxJPanel getMainPanel() {
		return mainPanel;
	}
	
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
	
	/**
	 * Create all model elements
	 */
	public void initModels()
	{
		model = new InclinedPlaneModel();
	}
	
	/**
	 * Create all controllers
	 */
	public void initControllers()
	{
		simController = new SimulationController(mainPanel.getSimulationControlJPanel1(), model);
		inclineAngleController = new InclineAngleComboBoxController(mainPanel.getInclinedPlaneExperimentJPanel().getLeftRampSteepnessComboBox(), model);
		startPosController = new StartPositionComboBoxController(mainPanel.getInclinedPlaneExperimentJPanel().getRunLengthComboBox(), model);
		ballTypeController = new BallTypeController(mainPanel.getInclinedPlaneExperimentJPanel().getBallTypeComboBox(), model);
		rampTypeController = new RampTypeController(mainPanel.getInclinedPlaneExperimentJPanel().getLeftRampTypeComboBox(), model);
		runLengthTypeController = new RunLengthTypeController(mainPanel.getInclinedPlaneExperimentJPanel().getRightRampType(), model);
		runLengthAngleController = new RunLengthAngleComboBoxController(mainPanel.getInclinedPlaneExperimentJPanel().getRightRampSteepnessComboBox(), model);
	}

	public void componentHidden(ComponentEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void componentMoved(ComponentEvent e) {
		// TODO Auto-generated method stub
		
	}

	/**
	 * When the component is resized, make sure to draw everything FRESH
	 */
	public void componentResized(ComponentEvent e) {
		mainPanel.invalidate();
		model.fireModelChangedEvent(null);
	}

	public void componentShown(ComponentEvent e) {
		// TODO Auto-generated method stub
		
	}
	
	public PedagogyJPanel getPedagogyPanel() {
		return pedagogyPanel;
	}
}
