package edu.assistment.experiments.inclinedplane.controller;

import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import edu.assistment.experiments.inclinedplane.model.InclinedPlaneModel;

public class RunLengthAngleSliderController implements ChangeListener
{
	private JSlider angleSlider;
	private InclinedPlaneModel model;
	
	/**
	 * @param angleSlider - JSlider with angles in degrees
	 */
	public RunLengthAngleSliderController(JSlider angleSlider, InclinedPlaneModel model)
	{
		this.angleSlider = angleSlider;
		this.model = model;
		this.angleSlider.addChangeListener(this);
	}
	
	/**
	 * Whenever the slider is moved, update the visualization
	 */
	public void stateChanged(ChangeEvent e) 
	{
		
		model.setRunTheta(Math.toRadians(angleSlider.getValue()));
		model.setBallAgainstRamp();
		model.fireModelChangedEvent(null);
	}
	
}
