package edu.assistment.experiments.inclinedplane.controller;

import javax.swing.JComboBox;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.assistment.experiments.inclinedplane.model.InclinedPlaneModel;

public class StartPositionComboBoxController implements ActionListener
{
	private JComboBox combo;
	private InclinedPlaneModel model;
	
	/**
	 * @param positionSlider - JSlider with angles in degrees
	 */
	public StartPositionComboBoxController(JComboBox combo, InclinedPlaneModel model)
	{
		this.combo = combo;
		this.model = model;
		this.combo.addActionListener(this);
	}
	
	/**
	 * Whenever the slider is moved, update the visualization
	 */
	public void actionPerformed(ActionEvent e) 
	{
		
		model.setBallStartPercent(.5 + .5*combo.getSelectedIndex());
		model.setBallAgainstRamp();
		model.fireModelChangedEvent(null);
	}
}
