package edu.assistment.experiments.inclinedplane.controller;

import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import edu.assistment.experiments.inclinedplane.model.InclinedPlaneModel;

public class StartPositionSliderController implements ChangeListener
{
	private JSlider positionSlider;
	private InclinedPlaneModel model;
	
	/**
	 * @param positionSlider - JSlider with angles in degrees
	 */
	public StartPositionSliderController(JSlider positionSlider, InclinedPlaneModel model)
	{
		this.positionSlider = positionSlider;
		this.model = model;
		this.positionSlider.addChangeListener(this);
	}
	
	/**
	 * Whenever the slider is moved, update the visualization
	 */
	public void stateChanged(ChangeEvent e) 
	{
		if(e.getSource() != positionSlider)
			throw new IllegalArgumentException("Source not: " + positionSlider.toString());
		
		model.setBallStartPercent((double)(positionSlider.getValue())/100.0);
		model.setBallAgainstRamp();
		model.fireModelChangedEvent(null);
	}
}
