package edu.assistment.experiments.inclinedplane.view;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.text.DecimalFormat;

import javax.swing.WindowConstants;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

import edu.assistment.experiments.inclinedplane.model.InclinedPlaneModel;
import edu.assistment.simulation.model.ModelChangeListener;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
* 
* 
* Display current stats about the simulation by receiving model
* change events.
*/
public class InclinedPlaneSimulationJPanel extends javax.swing.JPanel implements ModelChangeListener
{
	private JLabel ballRollPosition;
	private JLabel rollDistanceField;
	private JLabel timeField;
	private JLabel timeLabel;
	
	private InclinedPlaneModel model;

	/**
	* Auto-generated main method to display this 
	* JPanel inside a new JFrame.
	*/
	public static void main(String[] args) {
		JFrame frame = new JFrame();
		frame.getContentPane().add(new InclinedPlaneSimulationJPanel());
		frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		frame.pack();
		frame.setVisible(true);
	}
	
	public InclinedPlaneSimulationJPanel() {
		super();
		initGUI();
		model = new InclinedPlaneModel();
	}

	public InclinedPlaneSimulationJPanel(InclinedPlaneModel m) {
		super();
		model = m;
		m.addModelChangeListener(this);
		initGUI();
	}

	private void initGUI() {
		try {
			GridLayout thisLayout = new GridLayout(2, 2);
			thisLayout.setColumns(2);
			thisLayout.setHgap(5);
			thisLayout.setVgap(5);
			thisLayout.setRows(2);
			this.setLayout(thisLayout);
			this.setPreferredSize(new java.awt.Dimension(400, 57));
			{
				ballRollPosition = new JLabel();
				this.add(ballRollPosition);
				ballRollPosition.setText("Distance Rolled (m):");
				ballRollPosition.setHorizontalAlignment(SwingConstants.TRAILING);
			}
			{
				rollDistanceField = new JLabel();
				this.add(getRollDistanceField());
				rollDistanceField.setText("0.0m");
			}
			{
				timeLabel = new JLabel();
				this.add(getTimeLabel());
				timeLabel.setText("Time (seconds):");
				timeLabel.setHorizontalAlignment(SwingConstants.TRAILING);
			}
			{
				timeField = new JLabel();
				this.add(getTimeField());
				timeField.setText("0.0s");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public JLabel getRollDistanceField() {
		return rollDistanceField;
	}
	
	public JLabel getTimeLabel() {
		return timeLabel;
	}
	
	public JLabel getTimeField() {
		return timeField;
	}

	/**
	 * Update the time field and roll distance when the model changes
	 */
	public void modelChangeEvent(Object o)
	{
		DecimalFormat format = new DecimalFormat("#.0");
		
		getTimeField().setText(format.format(model.getCurrentTime()));
		getRollDistanceField().setText(Long.toString(Math.round(model.getDistanceRolledFromIncline())));
		getTimeField().validate();
		getTimeField().repaint();
		getRollDistanceField().validate();
		getRollDistanceField().repaint();
	}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

	
}
