package edu.assistment.simulation.model;

import java.util.ArrayList;
import java.util.List;

public abstract class Simulation 
{
	protected double current_time;
	private List<ModelChangeListener> listeners;

	public Simulation()
	{
		current_time = 0.0;
		listeners = new ArrayList<ModelChangeListener>();
	}
	
	public double getCurrentTime() { return Math.round(current_time*10) / 10.0; }
	public void setCurrentTime(double time) { current_time = time; }
	
	
	public void addModelChangeListener(ModelChangeListener mcl)
	{
		if(!listeners.contains(mcl))
		{
			listeners.add(mcl);
		}
	}
	
	public void fireModelChangedEvent(Object o)
	{
		for(ModelChangeListener mcl : listeners)
		{
			mcl.modelChangeEvent(o);
		}
	}
}
