package edu.assistment.simulation.model;

public class SimulationThread implements Runnable
{
	private Simulation sim;
	private SimulationEngine engine;
	
	private boolean isRunning;
	
	public SimulationThread(Simulation simulation, SimulationEngine eng)
	{
		sim = simulation;
		engine = eng;
		isRunning = true;
	}
	
	/**
	 * Forces the simulation to halt and destroys thread
	 */
	public void stopSimulation()
	{
		isRunning = false;
	}
	
	public boolean isRunning()
	{
		return isRunning;
	}
	
	public void run() 
	{
		while(isRunning && engine.nextStep())
		{
			sim.fireModelChangedEvent(null);
			try {
				Thread.sleep(50);
			} catch (InterruptedException e) 
			{
				e.printStackTrace();
				stopSimulation();
			}
		}
		
		stopSimulation();
	}
	

}
